

function cVaxMediaWebRTC() 
{
    var m_hLocalVideoStream = null;
    var m_hLocalAudioStream = null;

    var m_bActivatedMedia = false;

    var m_hProcMediaCaptureSuccess = null;
    var m_hProcMediaCaptureFailed = null;

    var m_bActivateAudio = false;
    var m_bActivateVideo = false;

    var m_bCapturedAudio = false;
    var m_bCapturedVideo = false;
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    this.ActivateMedia = function (bCaptureAudio, bCaptureVideo, hVideoConstraints, bShareScreen, hProcMediaCaptureSuccess, hProcMediaCaptureFailed)
    {
        m_hProcMediaCaptureSuccess = hProcMediaCaptureSuccess;
        m_hProcMediaCaptureFailed = hProcMediaCaptureFailed;

        ActivateMediaWebRTC(bCaptureAudio, bCaptureVideo, hVideoConstraints, bShareScreen);
    }

    this.DeactivateMedia = function ()
    {
        m_hProcMediaCaptureSuccess = null;
        DeactivateMediaWebRTC();
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    this.GetMediaVideoStream = function ()
    {
        return m_hLocalVideoStream;
    }

    this.GetMediaAudioStream = function ()
    {
        return m_hLocalAudioStream;
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    function OnMediaVideoSuccessWebRTC(hStream)
    {
        m_bCapturedVideo = true;
        m_hLocalVideoStream = hStream;

        if ((m_hProcMediaCaptureSuccess != null) && (m_bActivateAudio == false || m_bCapturedAudio == true))
        {
            m_hProcMediaCaptureSuccess(m_hLocalAudioStream, m_hLocalVideoStream);
        }
    }

    function OnMediaVideoFailedWebRTC(hError)
    {
        m_hProcMediaCaptureFailed(null, hError);
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////

    function OnMediaAudioSuccessWebRTC(hStream)
    {
        m_bCapturedAudio = true;
        m_hLocalAudioStream = hStream;

        if ((m_hProcMediaCaptureSuccess != null) && (m_bActivateVideo == false || m_bCapturedVideo == true))
        {
            m_hProcMediaCaptureSuccess(m_hLocalAudioStream, m_hLocalVideoStream);
        }
    }

    function ActivateMediaWebRTC(bCaptureAudio, bCaptureVideo, hVideoConstraints, bShareScreen)
    {
        if (m_bActivatedMedia)
            return;

        m_bActivatedMedia = true;

        m_bActivateAudio = bCaptureAudio;
        m_bActivateVideo = bCaptureVideo;

        m_bCapturedAudio = false;
        m_bCapturedVideo = false;
                
        if (bCaptureVideo)
        {
            if (hVideoConstraints == null)
            {
                hVideoConstraints =
                {
                    video: true,
                    audio: false
                };
            }
            
            if (bShareScreen)
            {
                navigator.mediaDevices.getDisplayMedia(hVideoConstraints)
                .then(OnMediaVideoSuccessWebRTC, OnMediaVideoFailedWebRTC)
                .catch(function (e)
                {
                    m_bActivateVideo = false;
                    m_hLocalVideoStream = null;
                });
            }
            else
            {
                navigator.mediaDevices.getUserMedia(hVideoConstraints)
                .then(OnMediaVideoSuccessWebRTC, OnMediaVideoFailedWebRTC)
                .catch(function (e)
                {
                    m_bActivateVideo = false;
                    m_hLocalVideoStream = null;
                });
            }
        }

        navigator.mediaDevices.getUserMedia({ audio: true, video: false })
        .then(OnMediaAudioSuccessWebRTC)
        .catch(function (e)
        {
            m_bActivatedMedia = false;
            m_bActivateAudio = false;
            m_hLocalAudioStream = null;

            ShowDialog('Unable to capture media audio device: ' + e.name);
        });
    }

    this.MuteMediaWebRTC = function(bMute)
    {
        if (m_hLocalAudioStream == null)
            return;
                
        m_hLocalAudioStream.getTracks().forEach(function (track) { track.enabled = !bMute; });
    }

    function DeactivateMediaWebRTC()
    {
        m_bActivatedMedia = false;

        m_bActivateAudio = false;
        m_bActivateVideo = false;

        m_bCapturedAudio = false;
        m_bCapturedVideo = false;
        
        if (m_hLocalAudioStream != null)
        {
            m_hLocalAudioStream.getTracks().forEach(function (track) { track.stop(); });
            m_hLocalAudioStream = null;
        }

        if (m_hLocalVideoStream != null)
        {
            m_hLocalVideoStream.getTracks().forEach(function (track) { track.stop(); });
            m_hLocalVideoStream = null;
        }
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
}