﻿/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Timer tick functions

function OnVaxPhoneIncomingCallBlickTimer() 
{
    m_objVaxPhoneIncomingCall.OnBlinkTick();
}

/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////

// Class cVaxPhoneIncomingCall

function cVaxPhoneIncomingCall()
{
    var m_hBlinkTimer = null;
        
    this.OnVaxInit = function () 
    {
        m_hBlinkTimer = null;
    }

    this.OnVaxUnInit = function () 
    {
        BlinkStop();
                
        while (ListIncomingCall.length > 0) 
            ListIncomingCall.remove(0);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallStatus = function (bIsStarted, sSDP, sCallId, sCallerName, sCallerId)
    {
        if (bIsStarted)
            this.OnIncomingCallStarted(sSDP, sCallId, sCallerName, sCallerId);
        else
            this.OnIncomingCallEnded(sCallId);
    }

    this.OnIncomingCallStarted = function (sSDP, sCallId, sCallerName, sCallerId) 
    {
        if (FindCall(sCallId) != -1) return;

        if (sCallerName.length != 0)
            AddCall("NAME: " + sCallerName + ", CLI: " + sCallerId, sCallId, sSDP);
        else
            AddCall("NAME: Unknown" + ", CLI: " + sCallerId, sCallId, sSDP);

        BlinkStart();
    }

    this.OnIncomingCallEnded = function (sCallId) 
    {
        nItemIndex = FindCall(sCallId);
        if (nItemIndex == -1) return;

        BlinkStop();
        RemoveCall(sCallId);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallRingToneStatus = function (bIsStarted, sCallId)
    {
        if (bIsStarted)
            m_objVaxPhoneTone.OnIncomingCallRingToneStarted();
        else
            m_objVaxPhoneTone.OnIncomingCallRingToneEnded();
    }
	
    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.BtnAccept_onclick = function () 
    {
	    if (ListIncomingCall.selectedIndex == -1) return;

	    var sJson = ListIncomingCall.options[ListIncomingCall.selectedIndex].value;
	    var objValue = JSON.parse(sJson);

	    sCallId = objValue.CallId;
	    sSDP = objValue.SDP;
                
        if (!m_objVaxWebPhoneLib.AcceptCall(sSDP, sCallId))
            return;
        
        m_objVaxPhoneTone.OnIncomingCallAccepted();

	    BlinkStop();
        RemoveCall(sCallId);
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

	this.BtnReject_onclick = function () 
    {
        if (ListIncomingCall.selectedIndex == -1) return;

	    var sJson = ListIncomingCall.options[ListIncomingCall.selectedIndex].value;
	    var objValue = JSON.parse(sJson);

	    sCallId = objValue.CallId;
	    sSDP = objValue.SDP;

        m_objVaxPhoneTone.OnIncomingCallRejected();
        m_objVaxWebPhoneLib.RejectCall(sCallId);
	    
	    BlinkStop();
        RemoveCall(sCallId);
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////
         
    function AddCall(sCallerId, sCallId, sSDP)
    {
		var objValue = {CallId: sCallId, SDP: sSDP};
        var sJson = JSON.stringify(objValue);
		
        ListIncomingCall.options[ListIncomingCall.options.length] = new Option(sCallerId, sJson);

        if (ListIncomingCall.selectedIndex == -1 && ListIncomingCall.length > 0)
            ListIncomingCall.selectedIndex = 0;
			
	}
    
    function FindCall(sCallId) 
    {
        for (nItemIndex = 0; nItemIndex < ListIncomingCall.length; nItemIndex++) 
        {
            var sJson = ListIncomingCall.options[nItemIndex].value;
	        var objValue = JSON.parse(sJson);
            
            if (objValue.CallId == sCallId) 
                return nItemIndex;
        }
        
        return -1;
    }

    function RemoveCall(sCallId)
    {
        nItemIndex = FindCall(sCallId);
        if (nItemIndex == -1) return;

        ListIncomingCall.remove(nItemIndex);

        if (ListIncomingCall.selectedIndex == -1 && ListIncomingCall.length > 0)
            ListIncomingCall.selectedIndex = 0;
	}

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function BlinkStart()
    {
        BlinkStop();

        m_hBlinkTimer = setInterval("OnVaxPhoneIncomingCallBlickTimer()", 500);
    }

    function BlinkStop()
    {
        if(m_hBlinkTimer != null)
        {
            clearInterval(m_hBlinkTimer);
            m_hBlinkTimer = null;
        }
        
        document.getElementById("PhoneTabLink").style.color = "";
    }

    this.OnBlinkTick = function () 
    {
        LinkText = document.getElementById("PhoneTabLink");
        LinkText.style.color = (LinkText.style.color == 'red' ? 'grey' : 'red');
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////
};