
///////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////

function cVaxPhoneEventSIP() 
{    
    var m_hEventOnInitialized = null;

    var m_hEventOnRegisterStatus = null;
    var m_hEventOnUnRegistered = null;
    var m_hSuccessToRegister = null;

    var m_hEventOnPhoneCallStatus = null;
    var m_hEventOnDialCallRingToneStatus = null;
    var m_hEventOnDialCallBusyToneStatus = null;

    var m_hEventOnCallClosed = null;
    var m_hEventOnPhoneCallHold = null;

    var m_hEventOnIncomingRefreshCallStarted = null;
    var m_hEventOnIncomingRefreshCallEnded = null;

    var m_hEventOnIncomingCallStatus = null;
    var m_hEventOnIncomingCallRingToneStatus = null;

    var m_hEventOnPhoneChatStatus = null;
    var m_hEventOnChatContactStatus = null;
    var m_hEventOnChatRecvMsgText = null;
    var m_hEventOnPhoneChatRecvMsgTypingStatus = null;

    var m_hEventBusyLampSubscribeSuccess = null;
    var m_hEventBusyLampSubscribeFailed = null;
    var m_hEventBusyLampContactStatus = null;

    var m_hEventOnAddCallHistory = null;
    var m_hEventOnVoiceMailMsg = null;

    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    this.SetEventInit = function (hEventOnInitialized)
    {
        m_hEventOnInitialized = hEventOnInitialized;
    }
        
    this.SetEventRegister = function (hEventOnRegisterStatus, hEventOnUnRegistered, hSuccessToRegister)
    {
        m_hEventOnRegisterStatus = hEventOnRegisterStatus;
        m_hEventOnUnRegistered = hEventOnUnRegistered;
        m_hSuccessToRegister = hSuccessToRegister;
    }
    
    this.SetEventCall = function (hEventOnPhoneCallStatus, hEventOnDialCallRingToneStatus, hEventOnDialCallBusyToneStatus, hEventOnIncomingCallStatus, hEventOnIncomingCallRingToneStatus, hEventOnCallClosed, hEventOnAddCallHistory, hEventOnPhoneCallHold, hEventOnIncomingRefreshCallStarted, hEventOnIncomingRefreshCallEnded)
    {
        m_hEventOnPhoneCallStatus = hEventOnPhoneCallStatus;

        m_hEventOnDialCallRingToneStatus = hEventOnDialCallRingToneStatus;
        m_hEventOnDialCallBusyToneStatus = hEventOnDialCallBusyToneStatus;

        m_hEventOnIncomingCallStatus = hEventOnIncomingCallStatus;
        m_hEventOnIncomingCallRingToneStatus = hEventOnIncomingCallRingToneStatus;

        m_hEventOnCallClosed = hEventOnCallClosed;
        m_hEventOnAddCallHistory = hEventOnAddCallHistory;
        m_hEventOnPhoneCallHold = hEventOnPhoneCallHold;

        m_hEventOnIncomingRefreshCallStarted = hEventOnIncomingRefreshCallStarted;
        m_hEventOnIncomingRefreshCallEnded = hEventOnIncomingRefreshCallEnded;
    }

    this.SetEventChat = function (hEventOnPhoneChatStatus, hEventOnChatContactStatus, hEventOnChatRecvMsgText, hEventOnPhoneChatRecvMsgTypingStatus)
    {
        m_hEventOnPhoneChatStatus = hEventOnPhoneChatStatus;
        m_hEventOnChatContactStatus = hEventOnChatContactStatus;

        m_hEventOnChatRecvMsgText = hEventOnChatRecvMsgText;
        m_hEventOnPhoneChatRecvMsgTypingStatus = hEventOnPhoneChatRecvMsgTypingStatus;
    }

    this.SetEventBusyLamp = function (hEventBusyLampSubscribeSuccess, hEventBusyLampSubscribeFailed, hEventBusyLampContactStatus)
    {
        m_hEventBusyLampSubscribeSuccess = hEventBusyLampSubscribeSuccess;
        m_hEventBusyLampSubscribeFailed = hEventBusyLampSubscribeFailed;
        m_hEventBusyLampContactStatus = hEventBusyLampContactStatus;
    }

    this.SetEventMainAll = function (hEventOnVoiceMailMsg)
    {
        m_hEventOnVoiceMailMsg = hEventOnVoiceMailMsg;
    }
    
    ///////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////

    this.OnWebSocketRecv = function (sMsgJSON) 
    {
        var objParsedJSON = null;

        try
        {
            objParsedJSON = JSON.parse(sMsgJSON);
        }
        catch (e)
        {
            alert(e + ':\n\n' + sMsgJSON); // Error in sMsgJSON (JSON)
            return;
        }

        var sEventName = objParsedJSON.EventName;
        var aEventParam = objParsedJSON.EventParam;

        if (sEventName == "OnInitialized") 
        {
            this.OnInitialized();
        }
                
        else if (sEventName == "OnConnectingToRegister") 
        {
            this.OnConnectingToRegister();
        }

        else if (sEventName == "OnTryingToRegister") 
        {
            this.OnTryingToRegister();
        }

        else if (sEventName == "OnFailToRegister") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnFailToRegister(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnSuccessToRegister") 
        {
            this.OnSuccessToRegister();
        }

        else if (sEventName == "OnConnectingToReRegister") 
        {
            this.OnConnectingToReRegister();
        }

        else if (sEventName == "OnTryingToReRegister") 
        {
            this.OnTryingToReRegister();
        }

        else if (sEventName == "OnFailToReRegister") 
        {
            var nStatusCode = aEventParam[0];
            var sReasonPhrase = aEventParam[1];

            this.OnFailToReRegister(nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnSuccessToReRegister") 
        {
            this.OnSuccessToReRegister();
        }

        else if (sEventName == "OnTryingToUnRegister") 
        {
            this.OnTryingToUnRegister();
        }

        else if (sEventName == "OnFailToUnRegister") 
        {
            this.OnFailToUnRegister();
        }

        else if (sEventName == "OnSuccessToUnRegister") 
        {
            this.OnSuccessToUnRegister();
        }

        else if (sEventName == "OnDialCallStarted") 
        {
            var nLineNo = aEventParam[0];
            var sCallerName = aEventParam[1];
            var sCallerId = aEventParam[2];
            var sDialNo = aEventParam[3];

            this.OnDialCallStarted(nLineNo, sCallerName, sCallerId, sDialNo);
        }

        else if (sEventName == "OnDialingCall") 
        {
            var nLineNo = aEventParam[0];
            var nStatusCode = aEventParam[1];
            var sReasonPhrase = aEventParam[2];

            this.OnDialingCall(nLineNo, nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnDialCallFailed") 
        {
            var nLineNo = aEventParam[0];
            var nStatusCode = aEventParam[1];
            var sReasonPhrase = aEventParam[2];
            var sContact = aEventParam[3];

            this.OnDialCallFailed(nLineNo, nStatusCode, sReasonPhrase, sContact);
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        else if (sEventName == "OnDialCallRingToneStarted") 
        {
            this.OnDialCallRingToneStarted();
        }

        else if (sEventName == "OnDialCallRingToneEnded") 
        {
            this.OnDialCallRingToneEnded();
        }

        else if (sEventName == "OnDialCallBusyToneStarted") 
        {
            this.OnDialCallBusyToneStarted();
        }

        else if (sEventName == "OnDialCallBusyToneEnded") 
        {
           this.OnDialCallBusyToneEnded();
        }

        //////////////////////////////////////////////////////////////////////////////
        //////////////////////////////////////////////////////////////////////////////

        else if (sEventName == "OnDialCallConnected") 
        {
            var nLineNo = aEventParam[0];
            var sSDP = aEventParam[1];
            var sToRTPIP = aEventParam[2];
            var nToRTPPort = aEventParam[3];

            this.OnDialCallConnected(nLineNo, sSDP, sToRTPIP, nToRTPPort);
        }

        else if (sEventName == "OnAcceptCallConnected") 
        {
            var nLineNo = aEventParam[0];
            var sToRTPIP = aEventParam[1];
            var nToRTPPort = aEventParam[2];

            this.OnAcceptCallConnected(nLineNo, sToRTPIP, nToRTPPort);
        }

        else if (sEventName == "OnHungupCall") 
        {
            var nLineNo = aEventParam[0];
            this.OnHungupCall(nLineNo);
        }

        else if (sEventName == "OnIncomingCallStarted") 
        {
            var sSDP = aEventParam[0];
            var sCallId = aEventParam[1];
            var sCallerName = aEventParam[2];

            var sCallerId = aEventParam[3];
            var sDialNo = aEventParam[4];

            var sFromURI = aEventParam[5];
            var sToURI = aEventParam[6];

            this.OnIncomingCallStarted(sSDP, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI);
        }

        else if (sEventName == "OnIncomingCallEnded") 
        {
            var sCallId = aEventParam[0];

            this.OnIncomingCallEnded(sCallId);
        }

        else if (sEventName == "OnIncomingCallRingToneStarted") 
        {
            var sCallId = aEventParam[0];

            this.OnIncomingCallRingToneStarted(sCallId);
        }

        else if (sEventName == "OnIncomingCallRingToneEnded") 
        {
            var sCallId = aEventParam[0];
            
            this.OnIncomingCallRingToneEnded(sCallId);
        }

        else if (sEventName == "OnTransferCallFailed") 
        {
            var nLineNo = aEventParam[0];
            var nStatusCode = aEventParam[1];
            var sReasonPhrase = aEventParam[2];

            this.OnTransferCallFailed(nLineNo, nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnTransferCallAccepted") 
        {
            var nLineNo = aEventParam[0];
            this.OnTransferCallAccepted(nLineNo);
        }

        else if (sEventName == "OnDigitDTMF") 
        {
            var nLineNo = aEventParam[0];
            var sDigit = aEventParam[1];

            this.OnDigitDTMF(nLineNo, sDigit)
        }

        else if (sEventName == "OnVoiceMailMsg") 
        {
            var bIsMsgWaiting = aEventParam[0];
            var nNewMsgCount = aEventParam[1];

            var nOldMsgCount = aEventParam[2];
            var nNewUrgentMsgCount = aEventParam[3];

            var nOldUrgentMsgCount = aEventParam[4];
            var sMsgAccount = aEventParam[5];

            this.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
        }

        else if (sEventName == "OnAudioSessionLost") 
        {
            var nLineNo = aEventParam[0];
            this.OnAudioSessionLost(nLineNo);
        }

        else if (sEventName == "OnSuccessToHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnSuccessToHold(nLineNo);
        }

        else if (sEventName == "OnTryingToHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnTryingToHold(nLineNo);
        }

        else if (sEventName == "OnFailToHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnFailToHold(nLineNo);
        }

        else if (sEventName == "OnSuccessToUnHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnSuccessToUnHold(nLineNo);
        }

        else if (sEventName == "OnTryingToUnHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnTryingToUnHold(nLineNo);
        }

        else if (sEventName == "OnFailToUnHold") 
        {
            var nLineNo = aEventParam[0];
            this.OnFailToUnHold(nLineNo);
        }

        else if (sEventName == "OnChatContactStatus") 
        {
            var sUserName = aEventParam[0];
            var nStatusId = aEventParam[1];

            this.OnChatContactStatus(sUserName, nStatusId);
        }

        else if (sEventName == "OnChatSendMsgTextSuccess") 
        {
            var sUserName = aEventParam[0];
            var sMsgText = aEventParam[1];
            var nUserValue32bit = aEventParam[2];

            this.OnChatSendMsgTextSuccess(sUserName, sMsgText, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTextFail") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];

            var sReasonPhrase = aEventParam[2];
            var sMsgText = aEventParam[3];

            var nUserValue32bit = aEventParam[4];

            this.OnChatSendMsgTextFail(sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTypingSuccess") 
        {
            var sUserName = aEventParam[0];
            var nUserValue32bit = aEventParam[1];

            this.OnChatSendMsgTypingSuccess(sUserName, nUserValue32bit);
        }

        else if (sEventName == "OnChatSendMsgTypingFail") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];

            var sReasonPhrase = aEventParam[2];
            var nUserValue32bit = aEventParam[3];

            this.OnChatSendMsgTypingFail(sUserName, nStatusCode, sReasonPhrase, nUserValue32bit)
        }

        else if (sEventName == "OnChatRecvMsgText") 
        {
            var sUserName = aEventParam[0];
            var sMsgText = aEventParam[1];

            var bIsChatContact = aEventParam[2];

            this.OnChatRecvMsgText(sUserName, sMsgText, bIsChatContact)
        }

        else if (sEventName == "OnChatRecvMsgTypingStart") 
        {
            var sUserName = aEventParam[0];

            this.OnChatRecvMsgTypingStart(sUserName);
        }

        else if (sEventName == "OnChatRecvMsgTypingStop") 
        {
            var sUserName = aEventParam[0];

            this.OnChatRecvMsgTypingStop(sUserName);
        }

        else if (sEventName == "OnHoldCall") 
        {
            var nLineNo = aEventParam[0];
            this.OnHoldCall(nLineNo);
        }

        else if (sEventName == "OnUnHoldCall") 
        {
            var nLineNo = aEventParam[0];
            this.OnUnHoldCall(nLineNo)
        }

        else if (sEventName == "OnAddCallHistory") 
        {
            var bOutboundCallType = aEventParam[0];
            var sCallerName = aEventParam[1];

            var sCallerId = aEventParam[2];
            var sDialNo = aEventParam[3];

            var nStartTime = aEventParam[4];
            var nEndTime = aEventParam[5];

            var nDuration = aEventParam[6];
            var nDayNo = aEventParam[7];
            var nHistoryTypeId = aEventParam[8];

            this.OnAddCallHistory(bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
        }

        else if (sEventName == "OnBusyLampSubscribeSuccess") 
        {
            var sUserName = aEventParam[0];

            this.OnBusyLampSubscribeSuccess(sUserName);
        }

        else if (sEventName == "OnBusyLampSubscribeFailed") 
        {
            var sUserName = aEventParam[0];
            var nStatusCode = aEventParam[1];
            var sReasonPhrase = aEventParam[2];

            this.OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase);
        }

        else if (sEventName == "OnBusyLampContactStatus") 
        {
            var sUserName = aEventParam[0];
            var nStatusId = aEventParam[1];

            this.OnBusyLampContactStatus(sUserName, nStatusId);
        }

        else if (sEventName == "OnIncomingRefreshCallEnded")
        {
            var nLineNo = aEventParam[0];
            var sSDP = aEventParam[1];

            this.OnIncomingRefreshCallEnded(nLineNo, sSDP);
        }

        else if (sEventName == "OnIncomingRefreshCallStarted")
        {
            var nLineNo = aEventParam[0];
            var bIsCallTypeOutbound = aEventParam[1];
            var sAudioFlowType = aEventParam[2];
            var sVideoFlowType = aEventParam[3];
            var sSDP = aEventParam[4];

            this.OnIncomingRefreshCallStarted(nLineNo, bIsCallTypeOutbound, sAudioFlowType, sVideoFlowType, sSDP);
        }

        else if (sEventName == "OnVaxErrorMsg") 
        {
            var sFuncName = aEventParam[0];
            var sErrorMsg = aEventParam[1];
            var nErrorCode = aEventParam[2];

            this.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode);
        }
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    this.OnInitialized = function () 
    {
        m_hEventOnInitialized();
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////

    this.OnRegisterStatus = function (sStatus)
    {
        m_hEventOnRegisterStatus(sStatus);
    }

    this.OnConnectingToRegister = function ()
    {
        this.OnRegisterStatus("Connecting to register.");
    }

    this.OnTryingToRegister = function ()
    {
        this.OnRegisterStatus("Trying to register.");
    }

    this.OnSuccessToRegister = function ()
    {
        this.OnRegisterStatus("Success to register.");
        m_hSuccessToRegister();
    }

    this.OnFailToRegister = function (nStatusCode, sReasonPhrase)
    {
        this.OnRegisterStatus("Failed: " + sReasonPhrase);
    }
        
    this.OnConnectingToReRegister = function ()
    {
        this.OnRegisterStatus("Connecting to re-register.");
    }

    this.OnTryingToReRegister = function ()
    {
        this.OnRegisterStatus("Trying to Re-Register.");
    }

    this.OnSuccessToReRegister = function ()
    {
        this.OnRegisterStatus("Success to Re-Register.");
    }

    this.OnFailToReRegister = function (nStatusCode, sReasonPhrase)
    {
        this.OnRegisterStatus("Failed: " + sReasonPhrase);
    }
        
    this.OnTryingToUnRegister = function ()
    {
        this.OnRegisterStatus("Trying to Unregister.");
    }

    this.OnSuccessToUnRegister = function ()
    {
        m_hEventOnUnRegistered();
        this.OnRegisterStatus("Unregistered successfully.");
    }

    this.OnFailToUnRegister = function ()
    {
        m_hEventOnUnRegistered();
        this.OnRegisterStatus("Fail to unregister.");
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnPhoneCallStatus = function (nLineNo, sStatus, sSDP, bIsDialFailed, bIsConnected)
    {
        m_hEventOnPhoneCallStatus(nLineNo, sStatus, sSDP, bIsDialFailed, bIsConnected);
    }

    this.OnDialCallStarted = function (nLineNo, sCallerName, sCallerId, sDialNo)
    {
         this.OnPhoneCallStatus(nLineNo, "Dialing", "", false, false);
    }

    this.OnDialingCall = function (nLineNo, nStatusCode, sReasonPhrase)
    {
         this.OnPhoneCallStatus(nLineNo, "Response: " + sReasonPhrase, "", false, false);
    }

    this.OnDialCallFailed = function (nLineNo, nStatusCode, sReasonPhrase, sContact)
    {
         this.OnPhoneCallStatus(nLineNo, "Response: " + sReasonPhrase, "", true, false);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnDialCallRingToneStatus = function (bIsStarted)
    {
        m_hEventOnDialCallRingToneStatus(bIsStarted);
    }

    this.OnDialCallRingToneStarted = function () 
    {
        this.OnDialCallRingToneStatus(true);
    }

    this.OnDialCallRingToneEnded = function () 
    {
        this.OnDialCallRingToneStatus(false);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnDialCallBusyToneStatus = function (bIsStarted)
    {
        m_hEventOnDialCallBusyToneStatus(bIsStarted);
    }

    this.OnDialCallBusyToneStarted = function () 
    {
        this.OnDialCallBusyToneStatus(true);
    }

    this.OnDialCallBusyToneEnded = function () 
    {
        this.OnDialCallBusyToneStatus(false);
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    this.OnDialCallConnected = function (nLineNo, sSDP, sToRTPIP, nToRTPPort) 
    {
         this.OnPhoneCallStatus(nLineNo, "Success to connect.", sSDP, false, true);
    }

    this.OnAcceptCallConnected = function (nLineNo, sToRTPIP, nToRTPPort) 
    {
         this.OnPhoneCallStatus(nLineNo, "Success to connect.", "", false, true);
    }
    
    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////
    
    this.OnHungupCall = function (nLineNo) 
    {  
        m_hEventOnCallClosed(nLineNo);
        this.OnPhoneCallStatus(nLineNo, "Hung up.", "", false, false);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallStatus = function (bIsStarted, sSDP, sCallId, sCallerName, sCallerId)
    {
        m_hEventOnIncomingCallStatus(bIsStarted, sSDP, sCallId, sCallerName, sCallerId);
    }

    this.OnIncomingCallStarted = function (sSDP, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI) 
    {
        this.OnIncomingCallStatus(true, sSDP, sCallId, sCallerName, sCallerId);
    }

    this.OnIncomingCallEnded = function (sCallId)
    {
        this.OnIncomingCallStatus(false, "", sCallId, "", "");
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingCallRingToneStatus = function (bIsStarted, sCallId)
    {
        m_hEventOnIncomingCallRingToneStatus(bIsStarted, sCallId);
    }

    this.OnIncomingCallRingToneStarted = function (sCallId) 
    {
        this.OnIncomingCallRingToneStatus(true, sCallId);
    }

    this.OnIncomingCallRingToneEnded = function (sCallId) 
    {
        this.OnIncomingCallRingToneStatus(false, sCallId);
    }

   /////////////////////////////////////////////////////////////////////////////////
   /////////////////////////////////////////////////////////////////////////////////

    this.OnTransferCallFailed = function (nLineNo, nStatusCode, sReasonPhrase) 
    {
         this.OnPhoneCallStatus(nLineNo, "Fail to Transfer: " + sReasonPhrase, "", false, false);
    }

    this.OnTransferCallAccepted = function (nLineNo) 
    {
         this.OnPhoneCallStatus(nLineNo, "Transfer accepted.", "", false, false);
    }

    this.OnDigitDTMF = function (nLineNo, sDigit) 
    {
         this.OnPhoneCallStatus(nLineNo, "Key-pressed: " + sDigit, "", false, false);
    }

    this.OnVoiceMailMsg = function (bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount) 
    {
        m_hEventOnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }
        
    this.OnAudioSessionLost = function (nLineNo) 
    {
         this.OnPhoneCallStatus(nLineNo, "Audio session lost.", "", false, false);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnPhoneCallHold = function (nLineNo, bIsOnHold)
    {
        m_hEventOnPhoneCallHold(nLineNo, bIsOnHold);
    }

    this.OnSuccessToHold = function (nLineNo)
    {
        this.OnPhoneCallHold(nLineNo, true);
        this.OnPhoneCallStatus(nLineNo, "Success to hold.", "", false, false);
    }

    this.OnTryingToHold = function (nLineNo)
    {
         this.OnPhoneCallStatus(nLineNo, "Trying to hold.", "", false, false);
    }

    this.OnFailToHold = function (nLineNo)
    {
         this.OnPhoneCallStatus(nLineNo, "Failed to hold.", "", false, false);
    }

    this.OnSuccessToUnHold = function (nLineNo)
    {
        this.OnPhoneCallHold(nLineNo, false);
        this.OnPhoneCallStatus(nLineNo, "Success to unhold.", "", false, false);
    }

    this.OnTryingToUnHold = function (nLineNo)
    {
         this.OnPhoneCallStatus(nLineNo, "Trying to unhold.", false, false);
    }

    this.OnFailToUnHold = function (nLineNo)
    {
         this.OnPhoneCallStatus(nLineNo, "Failed to unhold.", "", false, false);
    }

    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////
        
    this.OnChatContactStatus = function (sUserName, nStatusId) 
    {
        m_hEventOnChatContactStatus(sUserName, nStatusId);
    }

    this.OnChatRecvMsgText = function (sUserName, sMsgText, bIsChatContact)
    {
        m_hEventOnChatRecvMsgText(sUserName, sMsgText);
    }

    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////

    this.OnPhoneChatStatus = function (sStatus)
    {
        m_hEventOnPhoneChatStatus(sStatus);
    }

    this.OnChatSendMsgTextSuccess = function (sUserName, sMsgText, nUserValue32bit) 
    {
        this.OnPhoneChatStatus(sUserName + ": Success to send msg text.");
    }

    this.OnChatSendMsgTextFail = function (sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue32bit) 
    {
        this.OnPhoneChatStatus(sUserName + ": Failed to send msg text.");
    }

    this.OnChatSendMsgTypingSuccess = function (sUserName, nUserValue32bit) 
    {
        this.OnPhoneChatStatus(sUserName + ": Success to send status typing.");
    }

    this.OnChatSendMsgTypingFail = function (sUserName, nStatusCode, sReasonPhrase, nUserValue32bit) 
    {
        this.OnPhoneChatStatus(sUserName + ": Failed to send status typing.");
    }
        
    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////

    this.OnPhoneChatRecvMsgTypingStatus = function (bIsStarted, sUserName)
    {
        m_hEventOnPhoneChatRecvMsgTypingStatus(bIsStarted, sUserName);
    }

    this.OnChatRecvMsgTypingStart = function (sUserName) 
    {
        this.OnPhoneChatRecvMsgTypingStatus(true, sUserName);
    }

    this.OnChatRecvMsgTypingStop = function (sUserName) 
    {
        this.OnPhoneChatRecvMsgTypingStatus(false, sUserName);
    }

    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////

    this.OnAddCallHistory = function (bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId) 
    {
        m_hEventOnAddCallHistory(bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////

    this.OnBusyLampSubscribeSuccess = function (sUserName) 
    {
        m_hEventBusyLampSubscribeSuccess(sUserName)
    }

    this.OnBusyLampSubscribeFailed = function (sUserName, nStatusCode, sReasonPhrase)
    {
        m_hEventBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    }

    this.OnBusyLampContactStatus = function (sUserName, nStatusId) 
    {
        m_hEventBusyLampContactStatus(sUserName, nStatusId)
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.OnIncomingRefreshCallEnded = function (nLineNo, sSDP)
    {
        m_hEventOnIncomingRefreshCallEnded(nLineNo, sSDP)
    }

    this.OnIncomingRefreshCallStarted = function (nLineNo, sAudioFlowType, sVideoFlowType, sSDP)
    {
        m_hEventOnIncomingRefreshCallStarted(nLineNo, sAudioFlowType, sVideoFlowType, sSDP)
    }

    /////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////

    this.OnVaxErrorMsg = function (sFuncName, sErrorMsg, nErrorCode)
    {
        this.OnRegisterStatus(sFuncName + ": " + sErrorMsg);
        this.OnPhoneCallStatus(-1, sFuncName + ": " + sErrorMsg, "", false, false);
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////
}