﻿
//Class cVaxWebPhoneLib

function cVaxWebPhoneLib()
{
    const CALL_NORMAL_LINE_NO = 0;
    const CALL_CONSULT_LINE_NO = 1;

    var m_objVaxFuncSIP = new cVaxPhoneFuncSIP();
    var m_objVaxEventSIP = new cVaxPhoneEventSIP();
        
    var m_objVaxSocketWeb = new cVaxWebSocket();
    var m_objVaxMediaWebRTC = new cVaxMediaWebRTC();

    var m_aVaxWebRTC = null;
    var m_aBusyLine = null;

    var m_bRecvVideoWebRTC = true;

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    var m_sDisplayName = '';
    var m_sUserName = '';

    var m_sAuthLogin = '';
    var m_sAuthPwd = '';

    var m_sDomainRealm = '';
    var m_sServerAddr = '';
    var m_nServerPort = 0;
    var m_bRegister = false;

    var m_sWebSocketServerAddr = '';
    var m_nTypeDTMF = -1;
       
    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////
        
    this.OnLoadPage = function ()
    {
        m_aVaxWebRTC = new Array(2);

        m_aVaxWebRTC[CALL_NORMAL_LINE_NO] = new cVaxWebRTC();
        m_aVaxWebRTC[CALL_CONSULT_LINE_NO] = new cVaxWebRTC();

        m_aBusyLine = new Array(2);

        m_aBusyLine[CALL_NORMAL_LINE_NO] = false;
        m_aBusyLine[CALL_CONSULT_LINE_NO] = false;

        m_objVaxSocketWeb.SetEventWebSocket(OnWebSocketStatus, OnWebSocketRecv, OnWebSocketConnected)

        m_objVaxFuncSIP.SetEvent(OnWebSocketSend, OnCallClosed);

        m_objVaxEventSIP.SetEventInit(OnInitialized);
        m_objVaxEventSIP.SetEventMainAll(OnVoiceMailMsg);
        
        m_objVaxEventSIP.SetEventRegister(OnRegisterStatus, OnUnRegistered, OnSuccessToRegister);
        m_objVaxEventSIP.SetEventCall(OnPhoneCallStatus, OnDialCallRingToneStatus, OnDialCallBusyToneStatus, OnIncomingCallStatus, OnIncomingCallRingToneStatus, OnCallClosed, OnAddCallHistory, OnPhoneCallHold, OnIncomingRefreshCallStarted, OnIncomingRefreshCallEnded);

        m_objVaxEventSIP.SetEventChat(OnPhoneChatStatus, OnChatContactStatus, OnChatRecvMsgText, OnPhoneChatRecvMsgTypingStatus);
        m_objVaxEventSIP.SetEventBusyLamp(OnBusyLampSubscribeSuccess, OnBusyLampSubscribeFailed, OnBusyLampContactStatus);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function OnInitialized()
    {
        if (m_bRegister)
        {
            m_objVaxFuncSIP.RegisterToProxy(1800);
        }

        m_bRecvVideoWebRTC = true;
        m_objVaxMediaWebRTC.ActivateMedia(true, true, null, false, OnMediaCaptureSuccess, OnMediaCaptureFailed);

        m_objVaxMain.OnVaxInit();
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    this.VaxOnline = function (sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, bRegister, sWebSocketServerAddr)
    {
        m_aBusyLine[CALL_NORMAL_LINE_NO] = false;
        m_aBusyLine[CALL_CONSULT_LINE_NO] = false;

        m_sDisplayName = sDisplayName;
        m_sUserName = sUserName;

        m_sAuthLogin = sAuthLogin;
        m_sAuthPwd = sAuthPwd;

        m_sDomainRealm = sDomainRealm;
        m_sServerAddr = sServerAddr;
        m_nServerPort = nServerPort;

        m_bRegister = bRegister;
        m_sWebSocketServerAddr = sWebSocketServerAddr;

        m_objVaxSocketWeb.ConnectToServerWebSocket(sWebSocketServerAddr);
    }

    this.VaxOffline = function ()
    {
        m_objVaxFuncSIP.UnRegisterToProxy();

        m_objVaxMediaWebRTC.DeactivateMedia();
        m_objVaxMain.OnVaxUnInit();

        m_aBusyLine[CALL_NORMAL_LINE_NO] = false;
        m_aBusyLine[CALL_CONSULT_LINE_NO] = false;
    }

    this.VaxUnInitialize = function ()
    {
        m_aBusyLine[CALL_NORMAL_LINE_NO] = false;
        m_aBusyLine[CALL_CONSULT_LINE_NO] = false;

        m_objVaxFuncSIP.UnInitialize();
    }
        
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
        
    this.DialCall = function (sCallerName, sCallerId, sDialNo)
    {
        if (m_aBusyLine[CALL_NORMAL_LINE_NO] == true)
        {
            return false;
        }

        m_aBusyLine[CALL_NORMAL_LINE_NO] = true;
        
        var hLocalAudioStream = m_objVaxMediaWebRTC.GetMediaAudioStream();
        var hLocalVideoStream = m_objVaxMediaWebRTC.GetMediaVideoStream();

        var hAudioMediaOut = m_objVaxHtml.GetAudioMediaOut(CALL_NORMAL_LINE_NO);
        var hVideoMediaOut = m_objVaxHtml.GetVideoMediaOut();
               
        m_aVaxWebRTC[CALL_NORMAL_LINE_NO].CreateOfferWebRTC(CALL_NORMAL_LINE_NO, sCallerName, sCallerId, sDialNo, hLocalAudioStream, hLocalVideoStream, hAudioMediaOut, hVideoMediaOut, m_bRecvVideoWebRTC, OnOfferCreateSuccessWebRTC);
        return true;
    }

    this.DisconnectCall = function ()
    {
        m_aBusyLine[CALL_NORMAL_LINE_NO] = false;
        m_objVaxFuncSIP.DisconnectCall(CALL_NORMAL_LINE_NO);
    }
       
    this.AcceptCall = function (sSDP, sCallId)
    {
        if (m_aBusyLine[CALL_NORMAL_LINE_NO] == true)
        {
            OnPhoneCallStatus(CALL_NORMAL_LINE_NO, "Line is already busy.", "", false, false);
            return false;
        }

        m_aBusyLine[CALL_NORMAL_LINE_NO] = true;

        var hLocalAudioStream = m_objVaxMediaWebRTC.GetMediaAudioStream();
        var hLocalVideoStream = m_objVaxMediaWebRTC.GetMediaVideoStream();

        var hAudioMediaOut = m_objVaxHtml.GetAudioMediaOut(CALL_NORMAL_LINE_NO);
        var hVideoMediaOut = m_objVaxHtml.GetVideoMediaOut();
                
        m_aVaxWebRTC[CALL_NORMAL_LINE_NO].CreateAnswerWebRTC(CALL_NORMAL_LINE_NO, sSDP, sCallId, hLocalAudioStream, hLocalVideoStream, hAudioMediaOut, hVideoMediaOut, m_bRecvVideoWebRTC, OnAnswerCreateSuccessWebRTC);
        return true;
    }

    this.RejectCall = function (sCallId)
    {
        m_objVaxFuncSIP.RejectCall(sCallId);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.HoldCall = function ()
    {
        m_objVaxFuncSIP.HoldCall(CALL_NORMAL_LINE_NO);
    }

    this.UnHoldCall = function ()
    {
        m_objVaxFuncSIP.UnHoldCall(CALL_NORMAL_LINE_NO);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.TransferConsultDialCall = function (sCallerName, sCallerId, sDialNo)
    {
        if (m_aBusyLine[CALL_CONSULT_LINE_NO] == true)
        {
            OnPhoneCallStatus(CALL_CONSULT_LINE_NO, "Line is already busy.", "", false, false);
            return false;
        }

        m_aBusyLine[CALL_CONSULT_LINE_NO] = true;

        m_objVaxFuncSIP.HoldCall(CALL_NORMAL_LINE_NO);

        var hLocalAudioStream = m_objVaxMediaWebRTC.GetMediaAudioStream();
        var hAudioMediaOut = m_objVaxHtml.GetAudioMediaOut(CALL_CONSULT_LINE_NO);
        
        m_aVaxWebRTC[CALL_CONSULT_LINE_NO].CreateOfferWebRTC(CALL_CONSULT_LINE_NO, sCallerName, sCallerId, sDialNo, hLocalAudioStream, null, hAudioMediaOut, null, false, OnOfferCreateSuccessWebRTC);
        return true;
    }

    this.TransferConsultDisconnectCall = function ()
    {
        m_aBusyLine[CALL_CONSULT_LINE_NO] = false;
        m_objVaxFuncSIP.DisconnectCall(CALL_CONSULT_LINE_NO);
    }

    this.TransferConsultHoldCall = function ()
    {
        m_objVaxFuncSIP.HoldCall(CALL_CONSULT_LINE_NO);
    }

    this.TransferConsultUnHoldCall = function ()
    {
        m_objVaxFuncSIP.UnHoldCall(CALL_CONSULT_LINE_NO);
    }

    this.TransferConsultJoinCall = function ()
    {
        m_objVaxFuncSIP.TransferCallConsult(CALL_CONSULT_LINE_NO, CALL_NORMAL_LINE_NO);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.TransferCallBlind = function (sToUserName)
    {
        m_objVaxFuncSIP.TransferCallBlind(CALL_NORMAL_LINE_NO, sToUserName);
    }
        
    this.DigitDTMF = function (sDigit)
    {
        m_objVaxFuncSIP.DigitDTMF(CALL_NORMAL_LINE_NO, sDigit, m_nTypeDTMF);
    }

    this.ForceDigitDTMF = function (nTypeId, bEnable)
    {
        if (bEnable)
            m_nTypeDTMF = nTypeId;
        else
            nTypeId = -1;
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.DonotDisturb = function (bEnable)
    {
        m_objVaxFuncSIP.DonotDisturb(bEnable);
    }

    this.MuteMic = function (bMute)
    {
        m_objVaxMediaWebRTC.MuteMediaWebRTC(bMute);
    }
   
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.ChatAddContact = function (sUserName, bPresence)
    {
        m_objVaxFuncSIP.ChatAddContact(sUserName, bPresence);
    }

    this.ChatRemoveContact = function (sUserName)
    {
        m_objVaxFuncSIP.ChatRemoveContact(sUserName);
    }

    this.ChatSendMessageTyping = function (sUserName)
    {
        m_objVaxFuncSIP.ChatSendMessageTyping(sUserName, 0);
    }

    this.ChatSendMessageText = function (sUserName, sMsgText)
    {
        m_objVaxFuncSIP.ChatSendMessageText(sUserName, sMsgText, 101, 0);
    }
  
    this.ChatSetMyStatus = function (nStatusId)
    {
        m_objVaxFuncSIP.ChatSetMyStatus(nStatusId);
    }

    this.ChatSubscribeContactAll = function ()
    {
        m_objVaxFuncSIP.ChatSubscribeContactAll();
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.BusyLampAddContact = function (sUserName)
    {
        m_objVaxFuncSIP.BusyLampAddContact(sUserName);
    }

    this.BusyLampRemoveContact = function (sUserName)
    {
        m_objVaxFuncSIP.BusyLampRemoveContact(sUserName);
    }

    this.BusyLampSubscribeContactAll = function ()
    {
        m_objVaxFuncSIP.BusyLampSubscribeContactAll();
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    this.ForwardCall = function (bEnable, sToUserName)
    {
        m_objVaxFuncSIP.ForwardCall(bEnable, sToUserName);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnMediaCaptureFailed(hAudioError, hVideoError)
    {
        if (hVideoError != null)
        {

        }
    }

    function OnMediaCaptureSuccess(hAudioStream, hVideoStream)
    {
        if (hVideoStream != null)
        {
            var hVideoPreviewOut = m_objVaxHtml.GetVideoPreviewOut();

            if (hVideoPreviewOut != null)
                hVideoPreviewOut.srcObject = hVideoStream;
        }
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnUnRegistered()
    {
        m_objVaxMain.OnUnRegistered();
    }

    function OnRegisterStatus(sStatus)
    {
        m_objVaxMain.OnRegisterStatus(sStatus);
    }

    function OnSuccessToRegister()
    {
        m_objVaxMain.OnSuccessToRegister()
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnCallClosed(nLineNo)
    {
        m_aBusyLine[nLineNo] = false;

        m_aVaxWebRTC[nLineNo].CloseConnection();

        if (nLineNo == CALL_NORMAL_LINE_NO)
            m_objVaxMain.OnCallClosed();

        else if (nLineNo == CALL_CONSULT_LINE_NO)
            m_objVaxMain.OnTransferConsultCallClosed();
    }
    
    function OnPhoneCallStatus(nLineNo, sStatus, sSDP, bIsDialFailed, bIsConnected)
    {
        if (bIsDialFailed)
            m_aBusyLine[nLineNo] = false;
        
        if (bIsConnected && sSDP.length != 0)
        {
            m_aVaxWebRTC[nLineNo].SetAnswerRemoteWebRTC(sSDP);
        }
                                
        if (nLineNo == CALL_NORMAL_LINE_NO || nLineNo == -1)
            m_objVaxMain.OnPhoneCallStatus(sStatus, bIsDialFailed, bIsConnected);

        else if (nLineNo == CALL_CONSULT_LINE_NO)
            m_objVaxMain.OnPhoneTransferConsultCallStatus(sStatus);
    }

    function OnPhoneCallHold(nLineNo, bIsOnHold)
    {
        if (nLineNo == CALL_NORMAL_LINE_NO)
            m_objVaxMain.OnPhoneCallHold(bIsOnHold);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnDialCallRingToneStatus(bIsStarted)
    {
        m_objVaxMain.OnDialCallRingToneStatus(bIsStarted);
    }

    function OnDialCallBusyToneStatus(bIsStarted)
    {
        m_objVaxMain.OnDialCallBusyToneStatus(bIsStarted);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnIncomingCallStatus(bIsStarted, sSDP, sCallId, sCallerName, sCallerId)
    {
        if (bIsStarted)
            m_objVaxFuncSIP.PostRingingMsg();

        m_objVaxMain.OnIncomingCallStatus(bIsStarted, sSDP, sCallId, sCallerName, sCallerId);
    }

    function OnIncomingCallRingToneStatus(bIsStarted, sCallId)
    {
        m_objVaxMain.OnIncomingCallRingToneStatus(bIsStarted, sCallId);
    }
       
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
   
    function OnOfferCreateSuccessWebRTC(nLineNo, sSDP, sCallerName, sCallerId, sDialNo)
    {
        m_objVaxFuncSIP.DialCall(nLineNo, sSDP, sCallerName, sCallerId, sDialNo);
    }
            
    function OnAnswerCreateSuccessWebRTC(nLineNo, sSDP, sCallId)
    {
        m_objVaxFuncSIP.AcceptCall(nLineNo, sSDP, sCallId);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnWebSocketStatus(sStatus)
    {
        m_objVaxMain.OnWebSocketStatus(sStatus);
    }

    function OnWebSocketRecv(sData)
    {
        m_objVaxEventSIP.OnWebSocketRecv(sData);
    }

    function OnWebSocketConnected()
    {
        m_objVaxFuncSIP.Initialize(m_sDisplayName, m_sUserName, m_sAuthLogin, m_sAuthPwd, m_sDomainRealm, m_sServerAddr, m_nServerPort, m_sWebSocketServerAddr);
    }

    function OnWebSocketSend(sData)
    {
        m_objVaxSocketWeb.SendToServerWebSocket(sData);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnChatContactStatus(sUserName, nStatusId)
    {
        m_objVaxMain.OnChatContactStatus(sUserName, nStatusId);
    }

    function OnChatRecvMsgText(sUserName, sMsgText, bIsChatContact)
    {
        m_objVaxMain.OnChatRecvMsgText(sUserName, sMsgText);
    }

    function OnPhoneChatStatus(sStatus)
    {
        m_objVaxMain.OnPhoneChatStatus(sStatus);
    }

    function OnPhoneChatRecvMsgTypingStatus(bIsStarted, sUserName)
    {
        m_objVaxMain.OnPhoneChatRecvMsgTypingStatus(bIsStarted, sUserName);
    }

    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function OnBusyLampSubscribeSuccess(sUserName)
    {
        m_objVaxMain.OnBusyLampSubscribeSuccess(sUserName)
    }

    function OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    {
        m_objVaxMain.OnBusyLampSubscribeFailed(sUserName, nStatusCode, sReasonPhrase)
    }

    function OnBusyLampContactStatus(sUserName, nStatusId)
    {
        m_objVaxMain.OnBusyLampContactStatus(sUserName, nStatusId)
    }
        
    /////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////

    function OnAddCallHistory(bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId)
    {
        m_objVaxMain.OnAddCallHistory(bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId);
    }

    function OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)
    {
        m_objVaxMain.OnVoiceMailMsg(bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount);
    }

    function OnIncomingRefreshCallEnded(nLineNo, sSDP)
    {
        m_aVaxWebRTC[nLineNo].SetAnswerRemoteWebRTC(sSDP);
    }

    function OnIncomingRefreshCallStarted(nLineNo, sAudioFlowType, sVideoFlowType, sSDP)
    {
        m_aVaxWebRTC[nLineNo].CloseConnection();
        m_aVaxWebRTC[nLineNo] = null;

        m_aVaxWebRTC[nLineNo] = new cVaxWebRTC();

        var hLocalAudioStream = m_objVaxMediaWebRTC.GetMediaAudioStream();
        var hLocalVideoStream = m_objVaxMediaWebRTC.GetMediaVideoStream();

        var hAudioMediaOut = m_objVaxHtml.GetAudioMediaOut(nLineNo);
        var hVideoMediaOut = m_objVaxHtml.GetVideoMediaOut();

        var bRecvVideo = m_bRecvVideoWebRTC;

        if (sVideoFlowType == "inactive" || nLineNo == CALL_CONSULT_LINE_NO)
        {
            bRecvVideo = false;
            hLocalVideoStream = null;
        }

        if (sSDP.length == 0)
            m_aVaxWebRTC[nLineNo].CreateOfferWebRTC(nLineNo, "OnIncomingRefreshCallStarted", "", "", hLocalAudioStream, hLocalVideoStream, hAudioMediaOut, hVideoMediaOut, bRecvVideo, OnOfferCreateSuccessWebRTC);
        else
            m_aVaxWebRTC[nLineNo].CreateAnswerWebRTC(nLineNo, sSDP, "OnIncomingRefreshCallStarted", hLocalAudioStream, hLocalVideoStream, hAudioMediaOut, hVideoMediaOut, bRecvVideo, OnAnswerCreateSuccessWebRTC);
    }

    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////

    function OnOfferCreateSuccessWebRTC(nLineNo, sSDP, sCallerName, sCallerId, sDialNo)
    {
        if (sCallerName == 'OnIncomingRefreshCallStarted')
        {
            m_objVaxFuncSIP.AcceptRefreshCall(nLineNo, sSDP);
            return;
        }

        m_objVaxFuncSIP.DialCall(nLineNo, sSDP, sCallerName, sCallerId, sDialNo);
    }

    function OnAnswerCreateSuccessWebRTC(nLineNo, sSDP, sCallId)
    {
        if (sCallId == 'OnIncomingRefreshCallStarted')
        {
            m_objVaxFuncSIP.AcceptRefreshCall(nLineNo, sSDP);
            return;
        }

        m_objVaxFuncSIP.AcceptCall(nLineNo, sSDP, sCallId);
    }

}