﻿
//Class cVaxWebSocket

function cVaxWebSocket() 
{
    var m_hWebSocket = null;

    var m_hEventOnWebSocketStatus = null;
    var m_hEventOnWebSocketRecv = null;
    var m_hEventOnWebSocketConnected = null;
    
    var m_sWebSocketServerURL = "";
                
    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

    this.SetEventWebSocket = function (hEventOnWebSocketStatus, hEventOnWebSocketRecv, hEventOnWebSocketConnected)
    {
        m_hEventOnWebSocketStatus = hEventOnWebSocketStatus;
        m_hEventOnWebSocketRecv = hEventOnWebSocketRecv;
        m_hEventOnWebSocketConnected = hEventOnWebSocketConnected;
    }
    
    this.ConstructWebSocketURL = function (sServerAddr)
    {
        var sWebSocketIP = sServerAddr;
        var sDomainName = sWebSocketIP.replaceAll(".", "_");

        var sWebSocketServerURL = "wss://" + sDomainName + ".vaxphone.com:8080";
        return sWebSocketServerURL;
    }

    this.ConnectToServerWebSocket = function (sServerAddr)
    {
        m_bConnectedWebRTC = false;
        m_hEventOnWebSocketStatus("Trying to connect to Server WebRTC.");

        this.ConnectionWebSocket(sServerAddr);
    }

    this.ConnectionWebSocket = function (sServerAddr)
    {
        m_sWebSocketServerURL = this.ConstructWebSocketURL(sServerAddr);

        if (m_hWebSocket != null)
	    {
            m_hWebSocket.close();
	        m_hWebSocket = null;
	    }

        m_hWebSocket = new WebSocket(m_sWebSocketServerURL);

        m_hWebSocket.onerror = function (error)
        {
            m_bConnectedWebRTC = false;
            m_hEventOnWebSocketStatus("Failed to connect to Server WebRTC.");
        }

        m_hWebSocket.onopen = function (event)
        {
            m_bConnectedWebRTC = true;

            m_hEventOnWebSocketConnected();
            m_hEventOnWebSocketStatus("Success to connect to Server WebRTC.");
        }

        m_hWebSocket.onmessage = function (event)
        {
            if (event.data == "VaxWebPhoneALIVE")
            {
                if (m_bConnectedWebRTC)
                {
                    m_hWebSocket.send("VaxWebPhoneALIVE");
                }

                return;
            }

            m_hEventOnWebSocketRecv(event.data);
        }

        m_hWebSocket.onclose = function (event)
        {
            m_bConnectedWebRTC = false;
            m_hEventOnWebSocketStatus("Connection closed to Server WebRTC.");
        }
    }

    this.SendToServerWebSocket = function (sData)
    {
        if (m_bConnectedWebRTC)
            m_hWebSocket.send(sData);
    }

    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////

};
  

